This file contains a list of specific bugs that have been fixed, and patches
that have been applied in released versions.  Please see the NEWS file for
a summary of the major changes, and the ChangeLog file for a comprehensive
listing of all changes made to the code.

*5.2.6*

    snmplib:
      - [BUG 2027834]: Extend string print buffer by the minimum necessary
      - [BUG 2217367]: Fix a memory leak (backport of Patch 1616912)
      - [BUG 2838243]: Correct the output of unsigned values
      - [BUG 2919320]: Avoid accessing freed memory
      - [BUG 2922390]: Fix test for missing contextName parameter
      - [PATCH 2003450]: Fix a couple of 64-bit problems
      - [PATCH 2043018]: Fix recvfrom hangs
      - [PATCH 2258229]: Remove misleading comment
      - [PATCH 2479700]: Fix zoned IP address used as table indices
      - [PATCH 2505488]: Fix alarm behaviour on large clock skews
      - [PATCH 2538169]: Prevent infinite retries for invalid error-index
      - [PATCH 2689362]: Fix handling of IPv6 hostnames
      - [PATCH 2713841]: Fix runtime errors triggered by high-ASCII chars
      - [PATCH 2952034]: Return of the Great SuSE 'sprintf' Hunt
      - [PATCH 2952140]: Fix overflow counter32/gauge32 on 64-bit systems
      - Change the parsing of ranges to accept all valid values
      - Ensure O_CREATE mask is always specified
      - Make -LN stop dumping core.
      - Make bad debug levels report the offending symbol

    snmpd:
      - [BUG 1693039]: Be silent when insert fails
      - [BUG 2003144]: Increase size of AgentX packet build buffer
      - [BUG 2023803]: Remove irrelevant configure dependency (HP-UX 11)
      - [BUG 2822360]: Fix memory leak when building table OIDs
      - [BUG 2841008]: Protect against crash following failed AgentX response
      - [BUG 2894059]: Handle errors when counting interfaces
      - [BUG 2914410]: Fix crash on empty command lines
      - [PATCH 1550730]: Report errors from iterator-based handlers
      - [PATCH 1944581]: Don't core dump on long string index values
      - [PATCH 1977439]: Fix pass/_persist bug with SET oid value
      - [PATCH 2014204]: Support -g {groupname}
      - [PATCH 2022936]: Fix AgentX Counter64 decoding on 64-bit architectures
      - [PATCH 2082726]: correctly report NIC speeds higher than 4Gbit/s
      - [PATCH 2124288]: Fix setting of usmUserPrivProtocol at creation
      - [PATCH 2384779]: Fix handling of GetBulk with N>0,M==0
      - [PATCH 2693670]: Don't open AgentX sockets if other transports fail
      - [PATCH 2877518]: Fix handling of scoped AgentX variables
      - [PATCH 2883155]: Fix memory leak in proxy handling.
      - [PATCH 2887816]: Protect against division-by-zero crash
      - [PATCH 2912584]: Fix null OID handling in Agentx on 64bit
      - [PATCH 2950845]: Fix ifHighSpeed calculation
      - [PATCH 2952034]: Return of the Great SuSE 'sprintf' Hunt
      - [PATCH 2956657]: Handle over-length AgentX OIDs
      - [PATCH 2968642]: Catch overflow of pass-through command buffer
      - Ensure O_CREATE mask is always specified
      - Fix CVE-2008-4309 (GETBULK issue reported by Oscar Mira-Sanchez)
      - Fix memory leak when multiple interfaces have the same IPv6 address
      - Fix possible crash when 64-bit counters exceed 2^32
      - Fix two bugs with smux password support.
      - Improve parsing of -LS command line argument
      - Support large HW addresses (>6bytes)

    snmptrapd:
      - Remove glibc-specific printf-formatting tokens

    apps:
      - [BUG 1964136]: Drop NULL type from snmpset usage
      - [BUG 2811577]: Fix bug in GetBulk handling
      - [PATCH 2937996]: Add Date: header to email send by traptoemail
      - Improve parsing of -LS command line argument

    snmptable:
      - [BUG 2837998]: Handle missing instance subidentifiers in results
      - [PATCH 2850067]: Suppress extraneous "index" header token

    build:
      - [BUG 2023803]: Compilation problems on HP-UX 11.31
      - [BUG 2782700]: build failure when using --with-pkcs on Solaris
      - [PATCH 1681035]: improve net-snmp-config /bin/sh compatibility
      - [PATCH 1899762]: Tweak embedded_perl configure checks
      - [PATCH 2184039]: Misc fixes for freeing memory
      - [PATCH 2952020]: Set permission on testing directories
      - add --with-temp-file-pattern configure option
      - Fix 'make test TESTOPTS="-P tcp"'
      - Limit the use of _KERNEL definitions in configure

    documentation:
      - [BUG 2027129]: fix typo in snmpcmd.1

    mib2c:
      - [BUG 2827269]: Suppress non-ordered TODO comments
      - [BUG 2888569]: Fix generation of table columns array
      - [PATCH 2316127]: Fix bug in iterate_access generated code

    perl:
      - [BUG 1554817]: Fix class assigment so getRootOID works properly
      - [PATCH 2021444]: Support SNMPv2c in gettable
      - [PATCH 2022948]: Fix for Counter64 in perl subagent
      - [PATCH 2890931]: Better handling of Counter64 values

    AIX:
      - [BUG 2712670]: Agent crashes on AIX with hrStorage

    *BSD:
      - Fix a make test

    HP:
      - UX: BUG: 2779472: Filesystems missing in hrStorage

    Linux:
      - [PATCH 2926374]: Fix /proc/net/if_inet6 reading of ipAddressTable
      - fix rare race condition when reading RPM database
      - Fix build on modern distributions (using rpm-4.6)

    Solaris:
      - [PATCH 2012404]: deal with more than 10 interfaces
      - [PATCH 2751588]: Fix inconsistent/zero data being reported
      - Protect against missing package version

    Win32:
      - [PATCH 2688342]: Fix various VS2005 compiler warnings


*5.2.5*

    snmplib:
      - Change CONTAINER_INSERT to not do partial inserts
      - Corrected registering of
      - Deallocate the confmibs and confmibdirs
      - Do not leak memory whenever an udp address is
      - FEATURES: 851887: Report range information for
      - [BUG 1795840]: Signed 32-bit truncation logged
      - [BUG 1866655]: Handle parsing invalid OID
      - [BUG ]: Coverity #183: fix memory leak if
      - [PATCH 1687316]: Don't drop const from casts.
      - [PATCH 1768285]: Count MIB files correctly in
      - [PATCH 1775124]: Fix clientaddr functionality
      - [PATCH 1806336]: fix -LS option parsing
      - fix forwarding encoding
      - fix potential buffer overflow in sprintf for
      - patch: 1645698: fix 64-bit signed integer

    snmpd:
      - [BUG 1046327]: Reset "includeAllDisks" flag when
      - [BUG 1602286]: Don't let table holes block later
      - [BUG 1712988]: default and configurable maximum
      - [BUG 1745113]: Handle single-line (and zero-line)
      - [BUG 1748206]: Protect against failures to open
      - [BUG 1760633]: fix typo in debug message
      - [BUG 1771221]: Retain ifLastChange information on
      - [BUG 1792890]: include CIFS mounts when skipping
      - [BUG 1822360]: Fix spinlock helper error handling.
      - [PATCH 1687336]: Start using the enhanced
      - [PATCH 1698184]: Register non-default context
      - [PATCH 1700730]: Remove unused extern declaration.
      - [PATCH 1700732]: Fix debug output statements.
      - [PATCH 1700737]: Tidy up setSerialNo
      - [PATCH 1716548]: Fix help output so
      - [PATCH 1744157]: Report duplicate "extend/exec"
      - [PATCH 1746831]: fix process
      - [PATCH 1752934]: Fix off-by-one qsort error in
      - [PATCH 1753437]: Fix error index on failing SET
      - [PATCH 1753449]: Fix AgentX error propagation
      - [PATCH 1753463]: Fix AgentX subagent ping alarm
      - [PATCH 1774612]: More resilient process status
      - [PATCH 1783733]: Put the package version number
      - [PATCH 1826088]: Safranek: Use the right
      - [PATCH 1828839]: to provide better
      - [PATCH 1866823]: truncate 32 bit
      - [PATCH 1879261]: Add in inactive
      - [PATCH 1893468]: fixed registration of
      - patch: 1225440: Apply intent of patch: to delay
      - patch: 1595568: from cyril_margaria: fix
      - patch: 1617255: fix length of the history array
      - patch: 1700157: from afrika: fixes ordering of exec
      - patch: 1710632: from mavarley: fix memory leak on
      - patch: 1719254: from "Christan Jung": update
      - suppress annoying "registration != duplicate"
      - Handle device names with embedded spaces in
      - [BUG 1851047]: Do not try to do more handling of a value

    snmptrapd:
      - [PATCH 1767725]: Close all non standard file
      - patch: 1225440: Apply intent of patch: to

    build:
      - [BUG 1802833]: Ensure snmptrapd builds with
      - [BUG 1823381]: Valid MIB directory search path on
      - add "BuildRequires: perl-ExtUtils-Embed" to the
      - use libtool clean for removing files to ensure we

    building:
      - Check for support of static inline functions
      - Disable inlining on solaris as there are some

    library:
      - FEATURES: 454028: Detect and handle empty MIB
      - [PATCH 1921861]: Avoid endless loop after

    libsnmp:
      - [PATCH 1807489]: fix ignoring of display hints.
      - [PATCH 1898204]: Wescott: fix bug

    mib2c:
      - [BUG 1874059,1737068]: Handle MIB objects with

    misc:
      - Avoid calling debug macros with too few arguments.
      - avoid calling debug macros with too many
      - fix the -M switch for

    perl:
      - [BUG 1606062]: perl bulkwalk (async) coredump
      - [BUG 1747733]: More robust handling of undefined
      - [BUG 1826174]: Check for buffer overflow when
      - [BUG 1834539]: Consistent handling of OID parsing.
      - [PATCH 1811463]: perl async callback coredump
      - [PATCH 1914643]: fix issues with
      - fix SNMP SET for IP addresses on 64-bit
      - fix prerequisites for NetSNMP::TrapReceiver
      - fixed an extra brace in the docs pointed out by
      - install embedded perl init files for
      - patch: 1725049: fix bulkwalk in cases of non-repeater

    test:
      - support a -n flag to RUNTESTS to print the test

    HP:
      - UX: HP-UX needs _REENTRANT defined to pick up

    Solaris:
      - [BUG 1810814]: tcpTable missing entries and


*5.2.4*

    snmplib:
      - [PATCH 1548670]: Fix range checks for unsigned integers
      - [PATCH 1553447]: responses will get sent from the original
                           dest IP address when possible.
      - [PATCH 1562168]: check for a sock fd less than 0.
      - [PATCH 1565293]: UDPIPv6 transport reports wrong port number
      - [PATCH 1570650]: create a logging shutdown function to properly
                           clean up log registrations if needed.
      - [PATCH 1634620]: Fix leaks from create_user_from_session failure.
      - [PATCH 1640114]: Don't store trailing null character.
      - [PATCH 1641895]: Extend short view masks (as per RFC specs)
      - [PATCH 1642071]: Don't fiddle with the storage of pre-existing users.
      - [PATCH 1653670]: Consistent SNMPv3 behaviour when opening sessions.
      - [PATCH 1665543]: Handle VACM checks correctly.
      - [PATCH 1681030]: Better handling of empty apptype configs.
      - [BUG 1537459]: Fix missing MIB parsing tokens
      - [BUG 1540745]: Fix missing MIB parsing tokens
      - [BUG 1554989]: Fix handling of OID comparisons.
      - [BUG 1600171]: Support longer community strings in VACM config.
      - [BUG 1660061]: Validate engineIDs more strictly.
      - [BUG 1686384]: Document non-use of 'remote_port' field.

    snmpd:
      - [PATCH 1047706]: make end-of-mib-view RFC compliant
                         about the variable name it returns
      - [PATCH 1520286]: Prevent potential crash in Darwin.
      - [PATCH 1554827]: fix handling of failed proxy SET requests
      - [PATCH 1562688]: fix ping/reattach agentx code
      - [PATCH 1565703]: patch to fix rapid registrations/deregistration issues
      - [PATCH 1575984]: block SIGHUP during reconfig
      - [PATCH 1601188]: Handle signals properly when restarting the agent.
      - [PATCH 1637287]: Handle multiple target tags correctly.
      - [PATCH 1639282]: Save persistent snmpTargetParamsTable settings correctly.
      - [PATCH 1639360]: Fix snmpNotifyFilterProfileTable row creation.
      - [PATCH 1639726]: Report physical memory correctly on *BSD
      - [PATCH 1641332]: Include missing agent config definitions.
      - [PATCH 1641685]: Handle unresponsive AgentX subagents more reliably.
      - [PATCH 1644280]: Don't automatically probe for v3 EngineIDs.
      - [PATCH 1644280]: Use the correct engineID when sending v3 traps.
      - [PATCH 1644714]: replace last remaining instance of
                         deprecated copy_word by copy_nword.
      - [PATCH 1659623]: Handle SMUX peers with an empty password.
      - [PATCH 1665549]: Handle creating VACM entries correctly.
      - [PATCH 1666737]: include ipv6 counts in udp statistics.
      - [PATCH 1668952]: Ignore zombie processes.
      - [BUG  711465]: Fix BulkGet handling of override entries.
      - [BUG 1102058]: Skip non-mounted disks (e.g. swap partitions)
      - [BUG 1159908]: Fix memory leak
      - [BUG 1397895]: include missing interface declarations
      - [BUG 1413728]: Reference index values in debug output correctly.
      - [BUG 1427410]: Set auth engineID for SNMPv3 traps.
      - [BUG 1502267]: Build access list in the correct order.
      - [BUG 1527930]: fix smux authentication
      - [BUG 1546817]: Fix snmpEnterprise varbind when forwarding v1 traps.
      - [BUG 1559358]: check scanf results for diskio scanning
      - [BUG 1600432]: Handle signals properly when restarting the agent.
      - [BUG 1633595]: Fix AgentX handling of Counter64 values
      - [BUG 1677063]: Check for failed malloc calls.
      - [BUG 1685067]: More precise handling of SNMPv3-admin MIB tables.
      - [BUG 1685081]: Check for valid OID on Free/Undo passes.
      - patch from Wojtek Jawor to handle row deletion issues in dataset tables

    snmpdf:
      - [BUG 1515507]: Handle failed requests better

    snmptrapd:
      - [BUG 1638225]: Fix interpretation of transport address data.


    build:
      - [PATCH 1678298]: compile-subagent checks for bad HAVE_SIGNAL_H
      - [BUG 1096166]: Handle --without-logfile correctly.
      - [BUG 1564233]: Have configure test for rpm headers not just the libraries
      - [BUG 1567324]: Clarify prompting for user-supplied values.
      - [BUG 1585156]: Fix --without-perl-modules
      - add configure check for hasmntopt to fix the build on systems that lack it
      - yet another fix to address build issues with ethtool (on RH9).

    documentation:
      - [PATCH 1596028]: const fixes for the mib_api(3) manual page
      - [PATCH 1601261]: update README.smux
      - [PATCH 1604580]: SNMP(3) manual page corrections (spotted by tek-ops)
      - [BUG 1247164]: Document use of OID macros
      - [BUG 1407476]: Clarify MIB parsing toggle options and MIB comment handling.
      - [BUG 1577913]: add missing manual pages for executables, supplied by Debian

    mib2c:
      - [PATCH 1427712]: Better handling of non-integer values and valid column range.
      - [PATCH 1668171]: skip unknown cols in min/max range for tables, instead of error
      - [BUG 833673]: More focused size checks.
      - [BUG 1429472]: Protect against missing instances (and invalid objects)
      - [BUG 1479916]: Restore consistency in row creation code.
      - [BUG 1582972]: Handle @while@/@end@ properly.
      - [BUG 1585815]: fix mfd bits length calculation

    misc:
      - [BUG 1585250]: don't use deprecated options in start script
      - RPM spec file fixes for 64-bit platforms
      - "make test" fixes for non-UDP transports

    perl:
      - [PATCH 1575937]: fix usenumeric output in async varbinds so they
      - [PATCH 1627949]: from martin987: a perl agentx consumes memory
      - [BUG 1450669]: from martin987: a perl agentx consumes memory
      - Fixed the perl bulkwalk function
      - SNMP.pm fixes for 64-bit platforms
      - make perltest fixes for Solaris 2.6 and earlier, HP-UX, and IRIX
      -	return OIDs instead of empty strings.


    FreeBSD:
      - fix configure warning for sys/conf.h

    Linux:
      - [PATCH 1581294]: host-resources improvements
      - fix ethtool configure check for recent systems (e.g. FC6, RHEL5).

    Solaris:
      - [PATCH 1623447]: hrSWRun fix: <exited> instead of endOfTable for terminated processes
      - [BUG 1626153]: no hrSWRun informations on Solaris zones

    Win32:
      - [BUG 1662987]: compile error on Cygwin
